<?php
/*
Plugin Name: API for TheNewsletterPlugin
Description: API to add or remove user on the newsletter plugin
Version: 1.0
Author: Fabien Maurice
*/

function thenewsplu_wp_ajax_api()
{

	if (!isset($newsletter)) $newsletter = new Newsletter();

	$key = stripslashes($_REQUEST['nk']);
	if (empty($newsletter->options['api_key']) || $key != $newsletter->options['api_key']) {
    	die('Wrong API key');
	}

	if ($_REQUEST['act'] == 'add') {
		addsubscriber($_REQUEST,$newsletter);
	} elseif ($_REQUEST['act'] == 'del') {
		delsubscriber($_REQUEST,$newsletter);
	}

	wp_die();
	exit;	
}
add_action('wp_ajax_nopriv_api_thenewsplug', 'thenewsplu_wp_ajax_api');
add_action('wp_ajax_api_thenewsplug', 'thenewsplu_wp_ajax_api');

function delsubscriber(array $data,$newsletter) {
	global $wpdb;

	$email = $newsletter->normalize_email(stripslashes($data['ne']));
	$r = $wpdb->query($wpdb->prepare("delete from " . NEWSLETTER_USERS_TABLE . " where email=%s", $email));
	die($r = 0 ? 'ko' : 'ok');
}

function addsubscriber(array $data,$newsletter) {

	global $wpdb;

if (!is_email($data['ne'])) {
    die('Wrong email');
}

$subscriber = array();
$subscriber['name'] = stripslashes($data['nn']);
$subscriber['surname'] = stripslashes($data['ns']);
$subscriber['email'] = $newsletter->normalize_email(stripslashes($data['ne']));

if (is_array($data['nl'])) {
  foreach ($data['nl'] as $add_list) {
    $subscriber['list_' . $add_list] = 1;
  }
}
else if (!empty($data['nl'])) {
  $add_lists = explode('|', $data['nl']);
  foreach ($add_lists as $add_list) {
    $subscriber['list_' . $add_list] = 1;
  }
}

$options_feed = get_option('newsletter_feed', array());
if ($options_feed['add_new'] == 1) $subscriber['feed'] = 1;

$options_followup = get_option('newsletter_followup', array());
if ($options_followup['add_new'] == 1) {
  $subscriber['followup'] = 1;
  $subscriber['followup_time'] = time() + $options_followup['interval'] * 3600;
}

$subscriber['status'] = 'C';

// TODO: add control for already subscribed emails
NewsletterUsers::instance()->save_user($subscriber);
die('ok');

}